public class IntList
{
    private class Node
    {
		private int data;
		private Node next;

		public Node(int i, Node n)
		{
	 	   data = i;
	 	   next = n;
		}

		public Node(int i)
		{
	    	this(i, null);
		}

		public int getData()
		{
	  	  return data;
		}

		public Node getNext()
		{
		    return next;
		}

		public void setNext(Node n)
		{
		    next = n;
		}
    }

    private Node head;

    public IntList()
    {
		head = null;
    }

    public void addAtFront(int i)
    {
		head = new Node(i,head);
    }

    /*
    public void addAtEnd(int i)
    {
		if (head == null)
		    head = new Node(i,head);
		else
		{
            Node curr = head;
            while (curr.getNext() != null)
            	curr = curr.getNext();
			curr.setNext(new Node(i));
		}
    }
    */

    public void addAtEnd(int i)
    {
		head = addHelper(head,i);
    }

    private Node addHelper(Node h, int i)
    {
		if (h == null)
			return new Node(i);

		h.setNext(addHelper(h.getNext(),i));
		return h;
    }

	/*
    public void remove(int i)
    {
		if (head == null)
	    	return;

		if (head.getData() == i)
	    {
			head = head.getNext();
			return;
	    }

		for (Node curr = head; curr.getNext() != null; curr = curr.getNext())
	    	if (curr.getNext().getData() == i)
			{
		  	  curr.setNext(curr.getNext().getNext());
		  	  return;
			}
    }
    */

    public void remove(int i)
    {
		head = removeHelper(head,i);
    }

    private Node removeHelper(Node h, int i)
    {
		if (h == null)
			return null;

		if (h.getData() == i)
	    	return h.getNext();

		h.setNext(removeHelper(h.getNext(),i));
		return h;
    }

    public String toString()
    {
		String result = "";

		for (Node curr = head; curr != null; curr = curr.getNext())
	    {
			result += curr.getData() + " --> ";
	    }
		result += "null";

		return result;
    }

	public static void main(String[] args)
	{
		IntList list = new IntList();
		list.addAtFront(21);
		list.addAtFront(398);
		list.addAtEnd(42);
		System.out.println(list);
		list.remove(398);
		System.out.println(list);
		list.remove(21);
		System.out.println(list);
		list.remove(42);
		System.out.println(list);
    }
}
